<?php
//simple page for passing xml requests and returning xml results.  
//Requests are created and passed by fmxj javascript functions.
//returned xml is converted to JSON by fmxj function.

//Many thanks to Angelo Luchi for helping with this file!!! angelo@foxtailtech.com

 /*
 
LICENSE
 
(The MIT License)

Copyright (c) 2015 SeedCode SeedCode.Com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
 
error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED);
ini_set("display_errors" , false );
 
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept');

//if we're being hit from a browser (GET) then we just want to return phpinfo
if (isset($_GET)) {
   if($_GET["test"] === "true"){
     phpinfo();
     exit;
   }
}
//set this now that we know we're going for XML
header('Content-Type: application/xml');

//constants, some of these may need to be changed depending on your server configuration

//$serverAddress
//scenario 1: SINGLE MACHINE SET-UP: this shouldn't change although 127.0.0.1 should work if localhost is not configured. 
//scenario 2: MULTI MACHINE SET-UP FMS not requiring SSL: if the Web Server and WPE are on different machines then this should be set to the WPE IP Address
//scenario 3: MULTI MACHINE SET-UP FMS requiring SSL: IF SSL is required by FMS and Web Server and WPE are on different machines then you must specify the FQDN (fully qualified domain name) FMS.
$serverAddress = "localhost";

//$http
//This should only be changed to https for scenario 3 above.
$http = "http";
//$port

//This should only be changed to 443 for scenario 3 above.
$port = 80;

//$verifySSL
//false if disable verifying a SSL/TLS certificate chain
$verifySSL = true;

//don't edit this
$url = "$http://$serverAddress/fmi/xml/FMPXMLRESULT.xml";

//-------don't edit this block
//retrieve POST and transform to $req for cURL to FMS
if (isset($_POST)){
  $post = file_get_contents("php://input");
  //convert to array to extract are $u and $l
  $a = array();
  parse_str($post,$a);
  $account = $a["u"];
  $l = $a["l"];
  $lgth = strlen($post);
  $post = substr($post,0,($lgth-$l));
//-------end don't edit this block

  
  //edit method for logging users into FMS
  //Set to false if you plan on having all users logged into FMS with the same account
  $loginByName = false;

  //Define your FM credentials here
  //FM credentials from posted user name($account). The user name will be the DayBack account / email address. 
  //We recommend you replace the text between the quotes but don’t type, replace, or change the quotes themselves—copying and pasting is fine—because many text editors will swap those quotes for curly ones, inadvertently breaking this file
  if ($loginByName){
    //set credentials based on the user's DayBack account name / email address.
    if ($account === "jason@seedcode.com") {
      $u = "fmxj";
      $p = "fmxj";
    } 
    else if ($account === "<AnotherDayBackUser@somedomain.com>") {
      $u = "<AnotherFileMakerUser>";
      $p = "<AnotherFileMakerPassword>";
    }
  }
  //hardcoded credentials for all users
  else{
    $u = "fmxj";
    $p = "fmxj";
  }

  //---------- Do Not Edit Below This Line ------------------>

  //Test that we are passing a username
  if(empty($u)) {
    header('HTTP/1.1 401 Unauthorized', true, 401);
    exit();
  }

  $c = curl_init();
  curl_setopt($c, CURLOPT_URL, $url);
  curl_setopt($c, CURLOPT_TIMEOUT, 40);
  curl_setopt($c, CURLOPT_POST, true);
  curl_setopt($c, CURLOPT_POSTFIELDS, $post);
  curl_setopt($c, CURLOPT_USERPWD, $u . ":" . $p);
  if ($verifySSL === false) {
      curl_setopt($c, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
  }
  curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
  $result = curl_exec($c);
  curl_close($c);
  echo $result; 
};

?>